
library tags.showcase;

import 'dart:html';
import 'package:tags/tags.dart';

main() {
  registerTagsCustomElements();
  document.body.append(
      div(() {
        h1()..text = 'HTML Tags:';
        h2()..text = 'Text:';
        p(() {
          text('Lorem ipsum dolor sit amet,');
          b()..text = ' consectetur adipisicing elit, sed do ';
          text('eiusmod tempor incididunt ut labore et dolore magna.');
          i()..text = '  Ut enim ad minim veniam, quis nostrud exercitation ';
          text('ullamco laboris nisi ut aliquip ex commodo consequat.');
          u()..text = '  Duis aute irure dolor in reprehenderit in ';
          text('voluptate velit esse cillum dolore ');
          del()..text = 'eu fugiat nulla pariatur.';
        });
        h2()..text = 'Code:';
        pre(() {
          code()..text = 'abstract class Awesome {}';
        });
        h2()..text = 'Tables:';
        table(() {
          thead(() {
            tr(() {
              th()..text = 'First';
              th()..text = 'Last';
              th()..text = 'Age';
            });
          });
          tbody(() {      
            tr(() {
              td()..text = 'Jill';
              td()..text = 'Smith';
              td()..text = '29';
            });
            tr(() {
              td()..text = 'John';
              td()..text = 'Smith';
              td()..text = '33';
            });
          });
        });
        h2()..text = 'Lists:';
        h3()..text = 'Unordered:';
        ul(() {
          li()..text = 'Coffee';
          li()..text = 'Tea';
          li()..text = 'Milk';
        });
        h3()..text = 'Ordered:';
        ol(() {
          li()..text = 'One';
          li()..text = 'Two';
          li()..text = 'Three';
        });        
        h3()..text = 'Definition:';
        dl(() {
          dt()..text = 'Coffee';
          dd()..text = 'Black hot drink';
          dt()..text = 'Milk';
          dd()..text = 'White cold drink';
        });
        h1()..text = 'SVG Tags:';
        svg(() {          
          rect()    
          ..attributes = {
            'x'       : '0',
            'y'       : '0',
            'width'   : '80',
            'height'  : '80'
          }
          ..classes = ['green'];
          circle()
          ..attributes = {
            'cx'  : '40',
            'cy'  : '140',
            'r'   : '40'
          }
          ..classes = ['red'];
          ellipse()
          ..attributes = {
            'cx'  : '80',
            'cy'  : '220',
            'rx'  : '80',
            'ry'  : '40'
          }           
          ..classes = ['blue'];
          line()
          ..attributes = {
            'x1'  : '0',
            'y1'  : '280',
            'x2'  : '100',
            'y2'  : '280'
          }
          ..classes = ['green'];
          text('sometimes amazing things happen')
          ..attributes = {
            'x' : '0',
            'y' : '300'
          };
          polyline()
          ..attributes = {
            'points' : '0,320  60,320  30,360'            
          }
          ..classes = ['red'];
          polygon()
          ..attributes = {
            'points' : '60,320  60,360  40,360'            
          }
          ..classes = ['blue'];
        })
        ..attributes = {
          'width'   : '600',
          'height'  : '600',
          'viewBox' : '0 0 400 400'
        };
        h1()..text = 'Custom Tags:';
        h3()..text = 'Editable Label:';
        var _editableLabel;
        _editableLabel = editableLabel()
        ..text = 'Double-click to edit me.'
        ..onDoubleClick.listen((_) {
          _editableLabel.beginEdit();
        });
        h3()..text = 'Toggle Button:';
        toggleButton(() {
          span()..text = 'up'..classes = ['up'];
          span()..text = 'down'..classes = ['down'];
        });
        h3()..text = 'Toggle Open:';
        toggleOpen(() {
          a()..text = 'File'..classes = ['toggle'];
          ul(() {
            li(() => a()..href=''..text = 'New');
            li(() => a()..href=''..text = 'Open');
          })..classes = ['open'];
        });
      }));
}
