part of tags;

final Tag toggleButton = createTag((_) => new ToggleButton());

/// A button that allows toggling between an [isUp] and an [isDown] state.
class ToggleButton extends ButtonElement with Toggleable {
  
  static const TAG = 'toggle-button';
            
  /// Creates a new toggle button.
  factory ToggleButton() => new Element.tag('button', TAG);
  
  ToggleButton.created() : super.created() {
    ContentElement _content;
    children(this, () {
      shadow(() {
        _content = content()..select='.up';  
      });
    })
    ..onClick.listen((_) => isDown = !_isDown)
    ..onToggle.listen((bool down) {
      if (down) {
        _content.select = '.down';
      } else {
        _content.select = '.up';
      }
    });
  }
}
