part of tags;

/// A mixin that provides for toggling between an `up` and a `down` state.
abstract class Toggleable {
  
  bool _isDown = false;
  /// Whether or not this toggleable is down.
  bool get isDown => _isDown;
       set isDown(bool value) {
         if (value != _isDown) {
           _isDown = value;       
           _onToggle.add(_isDown);
         }
       }
  
  /// Whether or not this toggleable is up.
  bool get isUp => !_isDown;
  
  final _onToggle = new StreamController<bool>.broadcast();
  /// An observable stream of this toggleable's state transitions.
  /// 
  /// A `true` value represents [isDown] and a `false` value represents [isUp].
  Stream<bool> get onToggle => _onToggle.stream;
}
